import pandas as pd
import numpy as np
import datetime as dt
from sklearn.neighbors import NearestNeighbors as knn
from datetime import datetime
import warnings
import pytz
import matplotlib
import matplotlib.pyplot as plt
# get unix time from datetime as in cs
from scipy.stats import gaussian_kde
import numpy.core.defchararray as np_f
from numpy import inf
from sklearn import preprocessing
#!/usr/bin/python3

warnings.simplefilter(action='ignore', category=Warning)

'''
paths on remote server
path_save = 'C:/Users/hongteam/Desktop/Romana/'
path_ecobee = 'F:/Ecobee_2019/csvFiles/'
path = 'F:/Ecobee_2019/meta_data'
'''

#yrs = np.array([ 2015, 2016, 2017, 2018, 2018])



class directory:
    '''
    paths and file names
    '''
    path ='/home/romana/ecobee/meta_data'
    path_ecobee = '/home/romana/ecobee/2015/'
    files = list(['Identifier'])
    cols_t_set = list(['DateTime', 'HvacMode', 'Thermostat_Temperature', 'T_stp_cool', 'T_stp_heat'])

class get_temperatures:
    def remove_nan(self,data):
        return data[~np.isnan(data).any(axis=1)]

    def limits(self, data):
        x_max = np.max(np.max(data))
        x_min = np.min(np.min(data))
        return x_min, x_max

    def scale(self, data):
        x_min, x_max = self.limits(data)
        return (data -x_min)/(x_max - x_min)


def load_t():
    '''
    load all data from 2015 data set as the training set
    :return:
    '''
    dir = directory
    path = dir.path
    path_ecobee = dir.path_ecobee

    cols = dir.files
    filename_all = pd.read_csv(path + '.csv', usecols=cols)
    cols_tset = dir.cols_t_set
    filename_all = filename_all['Identifier'][0:100]
    changes_all = list()
    changes_day = list()
    data_points = list()
    temp_all = list()

    for filename in filename_all:
        try:
            '''
            currently taking only cooling set points changes
            '''
            data = pd.read_csv(path_ecobee + '/' + filename + '.csv', usecols=cols_tset)
            t_set = np.asarray(data['T_stp_cool'])
            t_set = t_set.astype(np.float)
            t_set_change = t_set[1:] - t_set[0:-1]
            t_diff = t_set_change[abs(t_set_change) > 0]
            changes = t_diff.shape[0]
            changes_all.append(changes)
            changes_day.append(changes / t_set.shape[0] * 12 * 24)
            data_points.append(t_set.shape[0])
            t_set = np.asarray(data['T_stp_cool'])
            temp = np.asarray(data['Thermostat_Temperature'])
            # input('temp')
            t_set = t_set.astype(np.float)
            t_set_change = t_set[1:] - t_set[0:-1]
            ind = np.where(t_set_change != 0)
            ind = list(ind)
            for i in ind[0]:
                if i > 48:
                    temp_all.append(temp[i - 48:i])
        except IOError:
            pass

    get_temperature = get_temperatures()
    temp_all = np.asarray(temp_all)
    temp_all = get_temperature.remove_nan(temp_all)
    temp_all = temp_all[0:10000, :]

    min_, max_ = get_temperature.limits(temp_all)
    temp_all = get_temperature.scale(temp_all)
    return list(temp_all), max_, min_
